Index: tools/ew.py
===================================================================
--- tools/ew.py	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ tools/ew.py	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -57,5 +57,6 @@
 
 def termemu_detect():
-	for termemu in ['xfce4-terminal', 'xterm']:
+	emus = ['gnome-terminal', 'xfce4-terminal', 'xterm']
+	for termemu in emus:
 		try:
 			subprocess.check_output('which ' + termemu, shell = True)
@@ -64,7 +65,15 @@
 			pass
 
+	print('Could not find any of the terminal emulators %s.'%(emus))
+	sys.exit(1)
+
 def run_in_console(cmd, title):
-	ecmd = cmd.replace('"', '\\"')
-	cmdline = termemu_detect() + ' -T ' + '"' + title + '"' + ' -e "' + ecmd + '"'
+	temu = termemu_detect()
+	if temu == 'gnome-terminal':
+		cmdline = temu + ' -- ' + cmd
+	else:
+		ecmd = cmd.replace('"', '\\"')
+		cmdline = temu + ' -T ' + '"' + title + '"' + ' -e "' + ecmd + '"'
+
 	print(cmdline)
 	if not is_override('dryrun'):
@@ -87,5 +96,23 @@
 
 def malta_options():
-	return '-cpu 4Kc'
+	return '-cpu 4Kc -append "console=devices/\\hw\\pci0\\00:0a.0\\com1\\a"'
+
+def find_firmware(name, environ_var, default_paths, extra_info=None):
+	"""Find firmware image(s)."""
+
+	if environ_var in os.environ:
+		return os.environ[environ_var]
+
+	for path in default_paths:
+		if os.path.exists(path):
+			return path
+
+	sys.stderr.write("Cannot find %s binary image(s)!\n" % name)
+	sys.stderr.write(
+	    "Either set %s environment variable accordingly or place the image(s) in one of the default locations: %s.\n" %
+	    (environ_var, ", ".join(default_paths)))
+	if extra_info is not None:
+		sys.stderr.write(extra_info)
+	return None
 
 def platform_to_qemu_options(platform, machine, processor):
@@ -94,4 +121,20 @@
 	elif platform == 'arm32':
 		return 'system-arm', '-M integratorcp'
+	elif platform == 'arm64':
+		# Search for the EDK2 firmware image
+		default_paths = (
+			'/usr/local/qemu-efi-aarch64/QEMU_EFI.fd', # Custom
+			'/usr/share/edk2/aarch64/QEMU_EFI.fd',     # Fedora
+			'/usr/share/qemu-efi-aarch64/QEMU_EFI.fd', # Ubuntu
+		)
+		extra_info = ("Pre-compiled binary can be obtained from "
+		    "http://snapshots.linaro.org/components/kernel/leg-virt-tianocore-edk2-upstream/latest/QEMU-AARCH64/RELEASE_GCC49/QEMU_EFI.fd.\n")
+		efi_path = find_firmware(
+		    "EDK2", 'EW_QEMU_EFI_AARCH64', default_paths, extra_info)
+		if efi_path is None:
+			raise Exception
+
+		return 'system-aarch64', \
+		    '-M virt -cpu cortex-a57 -m 1024 -bios %s' % efi_path
 	elif platform == 'ia32':
 		return 'system-i386', pc_options(32)
@@ -108,16 +151,10 @@
 		if processor == 'us':
 			return 'system-sparc64', '-M sun4u --prom-env boot-args="console=devices/\\hw\\pci0\\01:01.0\\com1\\a"'
-		elif processor == 'sun4v':
-			default_path = '/usr/local/opensparc/image/'
-		try:
-			if os.path.exists(default_path):
-				opensparc_bins = default_path
-			elif os.path.exists(os.environ['OPENSPARC_BINARIES']):
-				opensparc_bins = os.environ['OPENSPARC_BINARIES']
-			else:
-				raise Exception
-		except:
-			print("Cannot find OpenSPARC binary images!")
-			print("Either set OPENSPARC_BINARIES environment variable accordingly or place the images in %s." % (default_path))
+
+		# processor = 'sun4v'
+		opensparc_bins = find_firmware(
+		    "OpenSPARC", 'OPENSPARC_BINARIES',
+		    ('/usr/local/opensparc/image/', ))
+		if opensparc_bins is None:
 			raise Exception
 
@@ -208,6 +245,6 @@
 		cmdline += ' ' + options
 
-	cmdline += qemu_bd_options()
-
+	if (not 'hdd' in cfg.keys() or cfg['hdd']):
+		cmdline += qemu_bd_options()
 	if (not 'net' in cfg.keys()) or cfg['net']:
 		cmdline += qemu_net_options()
@@ -234,4 +271,11 @@
 	if cfg['image'] == 'image.iso':
 		cmdline += ' -boot d -cdrom image.iso'
+	elif cfg['image'] == 'image.iso@arm64':
+		# Define image.iso cdrom backend.
+		cmdline += ' -drive if=none,file=image.iso,id=cdrom,media=cdrom'
+		# Define scsi bus.
+		cmdline += ' -device virtio-scsi-device'
+		# Define cdrom frontend connected to this scsi bus.
+		cmdline += ' -device scsi-cd,drive=cdrom'
 	elif cfg['image'] == 'image.boot':
 		cmdline += ' -kernel image.boot'
@@ -276,4 +320,17 @@
 			'xhci' : False,
 			'tablet' : False
+		}
+	},
+	'arm64' : {
+		'virt' : {
+			'run' : qemu_run,
+			'image' : 'image.iso@arm64',
+			'audio' : False,
+			'console' : True,
+			'hdd' : False,
+			'net' : False,
+			'tablet' : False,
+			'usb' : False,
+			'xhci' : False
 		}
 	},
Index: tools/grub/grub-update.sh
===================================================================
--- tools/grub/grub-update.sh	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ tools/grub/grub-update.sh	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -40,10 +40,15 @@
 grub_rev="bc220962e366b1b46769ed6f9fa5be603ba58ab5"
 
+build_ia32amd64_pc=false
+build_ia32amd64_efi=false
+build_arm64_efi=false
+
 function grub_build()
 {
-	target="$1"
-	platform="$2"
+	platform="$1"
+	conf_target="$2"
+	conf_platform="$3"
 
-	./configure --prefix="$builddir/$target-$platform" --target="$target" --with-platform="$platform" --disable-werror || exit 1
+	./configure --prefix="$builddir/$platform" --target="$conf_target" --with-platform="$conf_platform" --disable-werror || exit 1
 	make clean || exit 1
 	make install || exit 1
@@ -55,10 +60,52 @@
 	platform="$2"
 
-	rm -rf "$helenosdir"/boot/"$gdir"/"$platform" || exit 1
-	cp -R "$builddir"/"$platform"/lib64/grub/"$platform" "$helenosdir"/boot/"$gdir" || exit 1
-	rm -f "$helenosdir"/boot/"$gdir"/"$platform"/*.image || exit 1
-	rm -f "$helenosdir"/boot/"$gdir"/"$platform"/*.module || exit 1
-	git add "$helenosdir"/boot/"$gdir"/"$platform" || exit 1
+	echo "$grub_rev" > "$helenosdir"/boot/grub/"$gdir"/REVISION || exit 1
+	rm -rf "$helenosdir"/boot/grub/"$gdir"/"$platform" || exit 1
+	cp -R "$builddir"/"$platform"/lib*/grub/"$platform" "$helenosdir"/boot/grub/"$gdir" || exit 1
+	rm -f "$helenosdir"/boot/grub/"$gdir"/"$platform"/*.image || exit 1
+	rm -f "$helenosdir"/boot/grub/"$gdir"/"$platform"/*.module || exit 1
+	git add "$helenosdir"/boot/grub/"$gdir"/"$platform" || exit 1
 }
+
+function show_usage()
+{
+	echo "Script to generate/update prebuild Grub2 in HelenOS source tree"
+	echo
+	echo "Syntax:"
+	echo " $0 <target>"
+	echo
+	echo "Possible targets are:"
+	echo " ia32+amd64-pc"
+	echo " ia32+amd64-efi"
+	echo " arm64-efi"
+	echo " all             build all targets"
+	echo
+
+	exit 3
+}
+
+if [ "$#" -ne "1" ] ; then
+	show_usage
+fi
+
+case "$1" in
+	ia32+amd64-pc)
+		build_ia32amd64_pc=true
+		;;
+	ia32+amd64-efi)
+		build_ia32amd64_efi=true
+		;;
+	arm64-efi)
+		build_arm64_efi=true
+		;;
+	all)
+		build_ia32amd64_pc=true
+		build_ia32amd64_efi=true
+		build_arm64_efi=true
+		;;
+	*)
+		show_usage
+		;;
+esac
 
 # Prepare a clone of Grub2 repo
@@ -72,41 +119,68 @@
 git reset --hard "$grub_rev" || exit 1
 
-echo "$grub_rev" >"$helenosdir"/boot/grub.pc/REVISION || exit 1
-echo "$grub_rev" > "$helenosdir"/boot/grub.efi/REVISION || exit 1
+./autogen.sh || exit 1
 
-# Build each platform to a different directory
-./autogen.sh || exit 1
-grub_build i386 pc
-grub_build i386 efi
-grub_build x86_64 efi
+if $build_ia32amd64_pc ; then
+	cd "$workdir" || exit 1
+	grub_build i386-pc i386 pc
 
-# Extract El Torrito boot image for i386-pc
-cd "$helenosdir"/boot/grub.pc || exit 1
-rm -f pc.img || exit 1
-"$builddir"/i386-pc/bin/grub-mkrescue -o phony --xorriso="$origdir/getimage.sh" || exit 1
+	# Extract El Torrito boot image for i386-pc
+	cd "$helenosdir"/boot/grub/ia32-pc || exit 1
+	rm -f pc.img || exit 1
+	"$builddir"/i386-pc/bin/grub-mkrescue -o phony --xorriso="$origdir/getimage.sh" || exit 1
 
-# Extract El Torrito boot image for i386-efi
-cd "$helenosdir"/boot/grub.efi || exit 1
-rm -f efi.img.gz || exit 1
-"$builddir"/i386-efi/bin/grub-mkrescue -o phony --xorriso="$origdir/getimage.sh" || exit 1
-mv efi.img i386-efi.img
+	grub_files_update ia32-pc i386-pc
+fi
 
-# Extract El Torrito boot image for x86_64-efi
-cd "$helenosdir"/boot/grub.efi || exit 1
-rm -f efi.img.gz || exit 1
-"$builddir"/x86_64-efi/bin/grub-mkrescue -o phony --xorriso="$origdir/getimage.sh" || exit 1
+if $build_ia32amd64_efi ; then
+	cd "$workdir" || exit 1
 
-# Combine El Torrito boot images for x86_64-efi and i386-efi
-mkdir tmp || exit 1
-mcopy -ns -i i386-efi.img ::efi tmp || exit 1
-mcopy -s -i efi.img tmp/* :: || exit 1
-gzip efi.img || exit 1
-rm -rf tmp || exit 1
-rm -f i386-efi.img || exit 1
+	# Build each platform to a different directory
+	grub_build i386-efi i386 efi
+	grub_build x86_64-efi x86_64 efi
 
-# Update Grub files for all platforms
-grub_files_update grub.pc i386-pc
-grub_files_update grub.efi i386-efi
-grub_files_update grub.efi x86_64-efi
+	# Extract El Torrito boot image for i386-efi
+	cd "$helenosdir"/boot/grub/ia32-efi || exit 1
+	rm -f efi.img.gz || exit 1
+	"$builddir"/i386-efi/bin/grub-mkrescue -o phony --xorriso="$origdir/getimage.sh" || exit 1
+	mv efi.img i386-efi.img
+
+	# Extract El Torrito boot image for x86_64-efi
+	cd "$helenosdir"/boot/grub/ia32-efi || exit 1
+	rm -f efi.img.gz || exit 1
+	"$builddir"/x86_64-efi/bin/grub-mkrescue -o phony --xorriso="$origdir/getimage.sh" || exit 1
+
+	# Combine El Torrito boot images for x86_64-efi and i386-efi
+	mkdir tmp || exit 1
+	mcopy -ns -i i386-efi.img ::efi tmp || exit 1
+	mcopy -s -i efi.img tmp/* :: || exit 1
+	gzip efi.img || exit 1
+	rm -rf tmp || exit 1
+	rm -f i386-efi.img || exit 1
+
+	# Update Grub files for all platforms
+	grub_files_update ia32-efi i386-efi
+	grub_files_update ia32-efi x86_64-efi
+fi
+
+if $build_arm64_efi ; then
+	cd "$workdir" || exit 1
+
+	# Check that the expected compiler is present on PATH
+	if ! [ -x "$(command -v aarch64-linux-gnu-gcc)" ] ; then
+		echo "Error: aarch64-linux-gnu-gcc is missing" >&2
+		exit 1
+	fi
+
+	grub_build arm64-efi aarch64-linux-gnu efi
+
+	# Extract El Torrito boot image for arm64-efi
+	cd "$helenosdir"/boot/grub/arm64-efi || exit 1
+	rm -f efi.img.gz || exit 1
+	"$builddir"/arm64-efi/bin/grub-mkrescue -o phony --xorriso="$origdir/getimage.sh" || exit 1
+	gzip efi.img || exit 1
+
+	grub_files_update arm64-efi arm64-efi
+fi
 
 echo "GRUB update successful."
Index: tools/grub/mkimage.sh
===================================================================
--- tools/grub/mkimage.sh	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ tools/grub/mkimage.sh	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -39,5 +39,5 @@
 orig_dir="$(cd "$(dirname "$0")" && pwd)"
 grub_tools_dir="$orig_dir/grub-build/i386-pc/bin"
-grub_mod_dir="$orig_dir/../../boot/grub.pc/i386-pc"
+grub_mod_dir="$orig_dir/../../boot/grub/ia32-pc/i386-pc"
 
 "$grub_tools_dir"/grub-mkimage --directory "$grub_mod_dir" \
Index: tools/toolchain.sh
===================================================================
--- tools/toolchain.sh	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ tools/toolchain.sh	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -66,4 +66,5 @@
 	echo " amd64      AMD64 (x86-64, x64)"
 	echo " arm32      ARM 32b"
+	echo " arm64      AArch64"
 	echo " ia32       IA-32 (x86, i386)"
 	echo " ia64       IA-64 (Itanium)"
@@ -103,5 +104,5 @@
 	
 	if [ -z "$1" ] || [ "$1" == "all" ] ; then
-		PLATFORMS=("amd64" "arm32" "ia32" "ia64" "mips32" "mips32eb" "ppc32" "riscv64" "sparc64")
+		PLATFORMS=("amd64" "arm32" "arm64" "ia32" "ia64" "mips32" "mips32eb" "ppc32" "riscv64" "sparc64")
 	else
 		PLATFORMS=("$1")
@@ -275,4 +276,7 @@
 		"arm32")
 			GNU_ARCH="arm"
+			;;
+		"arm64")
+			GNU_ARCH="aarch64"
 			;;
 		"ia32")
@@ -497,5 +501,5 @@
 		test_version
 		;;
-	amd64|arm32|ia32|ia64|mips32|mips32eb|ppc32|riscv64|sparc64)
+	amd64|arm32|arm64|ia32|ia64|mips32|mips32eb|ppc32|riscv64|sparc64)
 		prepare
 		build_target "$1"
@@ -505,4 +509,5 @@
 		build_target "amd64"
 		build_target "arm32"
+		build_target "arm64"
 		build_target "ia32"
 		build_target "ia64"
@@ -517,4 +522,5 @@
 		build_target "amd64"
 		build_target "arm32"
+		build_target "arm64"
 		build_target "ia32"
 		build_target "ia64"
@@ -528,4 +534,5 @@
 		build_target "amd64" &
 		build_target "arm32" &
+		build_target "arm64" &
 		build_target "ia32" &
 		build_target "ia64" &
@@ -543,16 +550,17 @@
 		wait
 
+		build_target "arm64" &
 		build_target "ia32" &
+		wait
+
 		build_target "ia64" &
+		build_target "mips32" &
 		wait
 
-		build_target "mips32" &
 		build_target "mips32eb" &
+		build_target "ppc32" &
 		wait
 
-		build_target "ppc32" &
 		build_target "riscv64" &
-		wait
-
 		build_target "sparc64" &
 		wait
Index: tools/travis.sh
===================================================================
--- tools/travis.sh	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ tools/travis.sh	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -52,4 +52,5 @@
 arm32/integratorcp:arm-helenos:image.boot
 arm32/raspberrypi:arm-helenos:uImage.bin
+arm64/virt:aarch64-helenos:image.iso
 ia32:i686-helenos:image.iso
 ia64/i460GX:ia64-helenos:image.boot
Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ uspace/Makefile	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -169,4 +169,5 @@
 	drv/char/ns8250 \
 	drv/char/pc-lpt \
+	drv/char/pl011 \
 	drv/char/pl050 \
 	drv/char/ski-con \
@@ -181,4 +182,5 @@
 	drv/hid/xtkbd \
 	drv/intctl/apic \
+	drv/intctl/gicv2 \
 	drv/intctl/i8259 \
 	drv/intctl/icp-ic \
@@ -191,4 +193,5 @@
 	drv/nic/virtio-net \
 	drv/platform/amdm37x \
+	drv/platform/arm64virt \
 	drv/platform/icp \
 	drv/platform/mac \
@@ -220,12 +223,9 @@
 #
 
-BASE_LIBS = \
+DIRS += \
+	lib/fs \
+	lib/block \
 	lib/c \
 	lib/cpp \
-	lib/untar
-
-LIBS = \
-	lib/fs \
-	lib/block \
 	lib/crypto \
 	lib/clui \
@@ -250,4 +250,5 @@
 	lib/ext4 \
 	lib/trackmod \
+	lib/untar \
 	lib/uri \
 	lib/usb \
@@ -263,15 +264,14 @@
 	lib/virtio
 
-BASE_BUILDS := $(addsuffix .build,$(BASE_LIBS))
-BUILDS := $(addsuffix .build,$(DIRS) $(LIBS))
-BUILDS_TESTS := $(addsuffix .build-test,$(DIRS) $(LIBS) $(BASE_LIBS))
-DEPS = $(addsuffix /deps.mk,$(DIRS) $(LIBS))
-CLEANS := $(addsuffix .clean,$(DIRS) $(LIBS) $(BASE_LIBS))
-
-.PHONY: all $(BASE_BUILDS) $(BUILDS) $(BUILDS_TESTS) $(CLEANS) clean export
+BUILDS := $(addsuffix .build,$(DIRS))
+BUILDS_TESTS := $(addsuffix .build-test,$(DIRS))
+DEPS = $(addsuffix /deps.mk,$(DIRS))
+CLEANS := $(addsuffix .clean,$(DIRS))
+
+.PHONY: all $(BUILDS) $(BUILDS_TESTS) $(CLEANS) clean export
 
 all: $(BUILDS) $(BUILDS_TESTS)
 
-$(BUILDS_TESTS): $(BASE_BUILDS) $(BUILDS)
+$(BUILDS_TESTS): $(BUILDS)
 	$(MAKE) -r -C $(basename $@) all-test PRECHECK=$(PRECHECK)
 
@@ -289,5 +289,5 @@
 	-$(MAKE) -r -C $(basename $@) fasterclean
 
-$(BASE_BUILDS) $(BUILDS):
+$(BUILDS):
 	$(MAKE) -r -C $(basename $@) all PRECHECK=$(PRECHECK)
 
@@ -295,5 +295,3 @@
 	$(MAKE) -r -C $(@D) deps.mk SELF_TARGET="$(@D).build"
 
-$(BUILDS): $(BASE_BUILDS)
-
 -include $(DEPS)
Index: uspace/Makefile.common
===================================================================
--- uspace/Makefile.common	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ uspace/Makefile.common	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -46,6 +46,4 @@
 #   STATIC_NEEDED      set to 'y' for init binaries, will build statically
 #                      linked version
-#   STATIC_ONLY        set to 'y' if binary cannot be linked dynamically
-#                      (e.g. uses thread-local variables)
 #
 # Optionally, for a library:
@@ -111,31 +109,29 @@
 START_FILES = $(LIBC_PREFIX)/crt0.o $(LIBC_PREFIX)/crt1.o
 
-AFLAGS = --fatal-warnings
 LDFLAGS = -Wl,--fatal-warnings,--warn-common
+
+STATIC_BUILD = n
 
 ifeq ($(STATIC_NEEDED),y)
 	STATIC_BUILD = y
-else
-	ifeq ($(STATIC_ONLY),y)
+endif
+
+ifneq ($(CONFIG_BUILD_SHARED_LIBS),y)
+	STATIC_BUILD = y
+endif
+
+ifneq ($(CONFIG_USE_SHARED_LIBS),y)
+	ifeq ($(LIBRARY),)
 		STATIC_BUILD = y
-	else
-		ifeq ($(CONFIG_BUILD_SHARED_LIBS),y)
-			ifeq ($(CONFIG_USE_SHARED_LIBS),y)
-				STATIC_BUILD = n
-			else
-				ifeq ($(LIBRARY),)
-					STATIC_BUILD = y
-				else
-					STATIC_BUILD = n
-				endif
-			endif
-		else
-			STATIC_BUILD = y
-		endif
 	endif
 endif
 
-ifneq ($(STATIC_BUILD),y)
-	LINK_DYNAMIC = y
+# LINK_DYNAMIC is only here to allow app/dltest to link dynamically in otherwise static build.
+ifeq ($(LINK_DYNAMIC),y)
+	STATIC_BUILD = n
+endif
+
+ifeq ($(STATIC_BUILD),y)
+	LDFLAGS += -static
 endif
 
@@ -152,8 +148,4 @@
 BASE_LIBS += -lgcc
 
-ifneq ($(LINK_DYNAMIC),y)
-	LDFLAGS += -static
-endif
-
 INCLUDES_FLAGS = $(LIBC_INCLUDES_FLAGS)
 
@@ -164,7 +156,14 @@
 INCLUDES_FLAGS += $(foreach lib,$(LIBS), -I$(LIB_PREFIX)/$(lib) -I$(LIB_PREFIX)/$(lib)/include)
 
-# TODO: get rid of this special case
-ifneq ($(filter math, $(LIBS)),)
-	INCLUDES_FLAGS += $(LIBMATH_INCLUDES_FLAGS)
+DEPLIBS := $(LIBS)
+
+ifneq ($(filter %.cpp %.cc %.cxx, $(SOURCES)),)
+	ifneq ($(LIBRARY),libcpp)
+		DEPLIBS += cpp
+	endif
+endif
+
+ifneq ($(LIBRARY),libc)
+	DEPLIBS += c
 endif
 
@@ -194,5 +193,6 @@
 	-Werror-implicit-function-declaration \
 	-Wsystem-headers \
-	-Wunknown-pragmas
+	-Wunknown-pragmas \
+	-Wa,--fatal-warnings
 
 # XXX: -fno-builtin-strftime is for a seemingly spurious format warning.
@@ -296,7 +296,6 @@
 
 LIB_CFLAGS = $(CFLAGS) -fPIC
+LIB_CXXFLAGS = $(CXXFLAGS) -fPIC
 LIB_LDFLAGS = $(LDFLAGS) -shared -Wl,-soname,$(LSONAME) -Wl,--no-undefined,--no-allow-shlib-undefined
-
-AS_CFLAGS := $(addprefix -Xassembler ,$(AFLAGS))
 
 OBJECTS := $(addsuffix .o,$(basename $(SOURCES)))
@@ -305,10 +304,6 @@
 DEPENDS := $(addsuffix .d,$(basename $(SOURCES))) $(addsuffix .test.d,$(basename $(TEST_SOURCES)))
 
-LIBTAGS := $(foreach lib,$(LIBS), $(USPACE_PREFIX)/lib/$(lib)/tag)
+LIBTAGS := $(foreach lib,$(DEPLIBS), $(USPACE_PREFIX)/lib/$(lib)/tag)
 LIBARGS := $(addprefix -L$(USPACE_PREFIX)/lib/, $(LIBS)) $(addprefix -l, $(LIBS))
-
-ifneq ($(LIBRARY),libc)
-	LIBTAGS := $(LIBC_PREFIX)/tag $(LIBTAGS)
-endif
 
 .PHONY: all all-test clean fasterclean depend
@@ -339,5 +334,5 @@
 deps.mk: Makefile
 	echo > $@.new
-	for lib in $(LIBS); do \
+	for lib in $(DEPLIBS); do \
 		echo "$(SELF_TARGET): lib/$$lib.build" >> $@.new; \
 	done
@@ -389,8 +384,8 @@
 
 %.o: %.S | depend
-	$(CC_JOB) -c -MD -MP $(DEFS) $(CFLAGS) $(EXTRA_CFLAGS) $(AS_CFLAGS)
+	$(CC_JOB) -c -MD -MP $(DEFS) $(CFLAGS) $(EXTRA_CFLAGS)
 
 %.o: %.s | depend
-	$(CC_JOB) -c -MD -MP $(DEFS) $(CFLAGS) $(EXTRA_CFLAGS) $(AS_CFLAGS)
+	$(CC_JOB) -c -MD -MP $(DEFS) $(CFLAGS) $(EXTRA_CFLAGS)
 
 %.o: %.c | depend
@@ -410,8 +405,8 @@
 
 %.lo: %.S | depend
-	$(CC_JOB) -c -MD -MP $(DEFS) $(LIB_CFLAGS) $(EXTRA_CFLAGS) $(AS_CFLAGS)
+	$(CC_JOB) -c -MD -MP $(DEFS) $(LIB_CFLAGS) $(EXTRA_CFLAGS)
 
 %.lo: %.s | depend
-	$(CC_JOB) -c -MD -MP $(DEFS) $(LIB_CFLAGS) $(EXTRA_CFLAGS) $(AS_CFLAGS)
+	$(CC_JOB) -c -MD -MP $(DEFS) $(LIB_CFLAGS) $(EXTRA_CFLAGS)
 
 %.lo: %.c | depend
@@ -419,11 +414,11 @@
 
 %.lo: %.cpp | depend
-	$(CXX_JOB) -c -MD -MP $(DEFS) $(CXXFLAGS) $(EXTRA_CXXFLAGS)
+	$(CXX_JOB) -c -MD -MP $(DEFS) $(LIB_CXXFLAGS) $(EXTRA_CXXFLAGS)
 
 %.lo: %.cxx | depend
-	$(CXX_JOB) -c -MD -MP $(DEFS) $(CXXFLAGS) $(EXTRA_CXXFLAGS)
+	$(CXX_JOB) -c -MD -MP $(DEFS) $(LIB_CXXFLAGS) $(EXTRA_CXXFLAGS)
 
 %.lo: %.cc | depend
-	$(CXX_JOB) -c -MD -MP $(DEFS) $(CXXFLAGS) $(EXTRA_CXXFLAGS)
+	$(CXX_JOB) -c -MD -MP $(DEFS) $(LIB_CXXFLAGS) $(EXTRA_CXXFLAGS)
 
 -include $(DEPENDS)
Index: uspace/app/barber/barber.c
===================================================================
--- uspace/app/barber/barber.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ uspace/app/barber/barber.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -45,6 +45,6 @@
 #include <window.h>
 #include <canvas.h>
-#include <surface.h>
-#include <codec/tga.gz.h>
+#include <draw/surface.h>
+#include <draw/codec.h>
 #include "images.h"
 
Index: uspace/app/bdsh/cmds/modules/ls/ls.c
===================================================================
--- uspace/app/bdsh/cmds/modules/ls/ls.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ uspace/app/bdsh/cmds/modules/ls/ls.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -42,4 +42,5 @@
 #include <vfs/vfs.h>
 #include <str.h>
+#include <cap.h>
 
 #include "ls.h"
@@ -58,4 +59,6 @@
 	{ "unsort", no_argument, 0, 'u' },
 	{ "recursive", no_argument, 0, 'r' },
+	{ "exact-size", no_argument, 0, 'e' },
+	{ "single-column", no_argument, 0, '1' },
 	{ 0, 0, 0, 0 }
 };
@@ -63,6 +66,8 @@
 /* Prototypes for the ls command, excluding entry points. */
 static unsigned int ls_start(ls_job_t *);
-static void ls_print(struct dir_elem_t *);
-static int ls_cmp(const void *, const void *);
+static errno_t ls_print(struct dir_elem_t *);
+static errno_t ls_print_single_column(struct dir_elem_t *);
+static int ls_cmp_type_name(const void *, const void *);
+static int ls_cmp_name(const void *, const void *);
 static signed int ls_scan_dir(const char *, DIR *, struct dir_elem_t **);
 static unsigned int ls_recursive(const char *, DIR *);
@@ -74,4 +79,7 @@
 	ls->sort = 1;
 
+	ls->exact_size = false;
+	ls->single_column = false;
+	ls->printer = ls_print;
 	return 1;
 }
@@ -88,12 +96,51 @@
  * @param de		Directory element.
  */
-static void ls_print(struct dir_elem_t *de)
-{
-	if (de->s.is_file)
-		printf("%-40s\t%llu\n", de->name, (long long) de->s.size);
-	else if (de->s.is_directory)
-		printf("%-40s\t<dir>\n", de->name);
+static errno_t ls_print(struct dir_elem_t *de)
+{
+	int width = 13;
+
+	if (de->s.is_file) {
+		if (ls.exact_size) {
+			printf("%-40s\t%*llu\n", de->name, width, (long long) de->s.size);
+			return EOK;
+		}
+
+		cap_spec_t cap;
+		cap_from_blocks(de->s.size, 1, &cap);
+		cap_simplify(&cap);
+
+		char *rptr;
+		errno_t rc = cap_format(&cap, &rptr);
+		if (rc != EOK) {
+			return rc;
+		}
+
+		char *sep = str_rchr(rptr, ' ');
+		if (sep == NULL) {
+			free(rptr);
+			return ENOENT;
+		}
+
+		*sep = '\0';
+
+		printf("%-40s\t%*s %2s\n", de->name, width - 3, rptr, sep + 1);
+		free(rptr);
+	} else if (de->s.is_directory)
+		printf("%-40s\t%*s\n", de->name, width, "<dir>");
 	else
 		printf("%-40s\n", de->name);
+
+	return EOK;
+}
+
+static errno_t ls_print_single_column(struct dir_elem_t *de)
+{
+	if (de->s.is_file) {
+		printf("%s\n", de->name);
+	} else {
+		printf("%s/\n", de->name);
+	}
+
+	return EOK;
 }
 
@@ -109,5 +156,5 @@
  * @return		-1 if a < b, 1 otherwise.
  */
-static int ls_cmp(const void *a, const void *b)
+static int ls_cmp_type_name(const void *a, const void *b)
 {
 	struct dir_elem_t const *da = a;
@@ -120,4 +167,18 @@
 	else
 		return 1;
+}
+
+/** Compare directories/files per name
+ *
+ * This comparision ignores the type of
+ * the node. Sorted will strictly by name.
+ *
+ */
+static int ls_cmp_name(const void *a, const void *b)
+{
+	struct dir_elem_t const *da = a;
+	struct dir_elem_t const *db = b;
+
+	return str_cmp(da->name, db->name);
 }
 
@@ -192,9 +253,16 @@
 	}
 
-	if (ls.sort)
-		qsort(&tosort[0], nbdirs, sizeof(struct dir_elem_t), ls_cmp);
-
-	for (i = 0; i < nbdirs; i++)
-		ls_print(&tosort[i]);
+	if (ls.sort) {
+		int (*compar)(const void *, const void *);
+		compar = ls.single_column ? ls_cmp_name : ls_cmp_type_name;
+		qsort(&tosort[0], nbdirs, sizeof(struct dir_elem_t), compar);
+	}
+
+	for (i = 0; i < nbdirs; i++) {
+		if (ls.printer(&tosort[i]) != EOK) {
+			cli_error(CL_ENOMEM, "%s: Out of memory", cmdname);
+			goto out;
+		}
+	}
 
 	/* Populate the directory list. */
@@ -333,7 +401,9 @@
 		    "If not path is given, the current working directory is used.\n"
 		    "Options:\n"
-		    "  -h, --help       A short option summary\n"
-		    "  -u, --unsort     Do not sort directory entries\n"
-		    "  -r, --recursive  List subdirectories recursively\n",
+		    "  -h, --help            A short option summary\n"
+		    "  -u, --unsort          Do not sort directory entries\n"
+		    "  -r, --recursive       List subdirectories recursively\n"
+		    "  -e, --exact-size      File sizes will be unformatted (raw bytes count)\n"
+		    "  -1, --single-column   Only the names will be returned\n",
 		    cmdname);
 	}
@@ -364,5 +434,5 @@
 
 	while (c != -1) {
-		c = getopt_long(argc, argv, "hur", long_options, &opt_ind);
+		c = getopt_long(argc, argv, "hure1", long_options, &opt_ind);
 		switch (c) {
 		case 'h':
@@ -375,4 +445,11 @@
 			ls.recursive = 1;
 			break;
+		case 'e':
+			ls.exact_size = true;
+			break;
+		case '1':
+			ls.single_column = true;
+			ls.printer = ls_print_single_column;
+			break;
 		}
 	}
@@ -400,5 +477,8 @@
 	switch (scope) {
 	case LS_FILE:
-		ls_print(&de);
+		if (ls.printer(&de) != EOK) {
+			cli_error(CL_ENOMEM, "%s: Out of memory", cmdname);
+			return CMD_FAILURE;
+		}
 		break;
 	case LS_DIR:
Index: uspace/app/bdsh/cmds/modules/ls/ls.h
===================================================================
--- uspace/app/bdsh/cmds/modules/ls/ls.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ uspace/app/bdsh/cmds/modules/ls/ls.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -8,11 +8,4 @@
 #define LS_FILE  1
 #define LS_DIR   2
-
-typedef struct {
-	/* Options set at runtime. */
-	unsigned int recursive;
-	unsigned int sort;
-
-} ls_job_t;
 
 /** Structure to represent a directory entry.
@@ -26,3 +19,14 @@
 };
 
+typedef struct {
+	/* Options set at runtime. */
+	unsigned int recursive;
+	unsigned int sort;
+
+	bool single_column;
+	bool exact_size;
+
+	errno_t (*printer)(struct dir_elem_t *);
+} ls_job_t;
+
 #endif
Index: uspace/app/bdsh/compl.c
===================================================================
--- uspace/app/bdsh/compl.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ uspace/app/bdsh/compl.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -42,4 +42,5 @@
 #include "exec.h"
 #include "tok.h"
+#include "util.h"
 
 static errno_t compl_init(wchar_t *text, size_t pos, size_t *cstart, void **state);
@@ -214,6 +215,4 @@
 		}
 		*cstart += rpath_sep + 1 - prefix;
-		free(prefix);
-		prefix = NULL;
 
 		cs->path_list = malloc(sizeof(char *) * 2);
@@ -222,5 +221,22 @@
 			goto error;
 		}
-		cs->path_list[0] = dirname;
+
+		if (!is_path(prefix) && cs->is_command) {
+			cs->path_list[0] = malloc(sizeof(char) * PATH_MAX);
+			if (cs->path_list[0] == NULL) {
+				retval = ENOMEM;
+				goto error;
+			}
+
+			int ret = snprintf(cs->path_list[0], PATH_MAX, "%s/%s", search_dir[0], dirname);
+			if (ret < 0 || ret >= PATH_MAX) {
+				retval = ENOMEM;
+				goto error;
+			}
+		} else {
+			cs->path_list[0] = dirname;
+		}
+
+		free(prefix);
 		cs->path_list[1] = NULL;
 		/*
Index: uspace/app/bdsh/exec.c
===================================================================
--- uspace/app/bdsh/exec.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ uspace/app/bdsh/exec.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -47,8 +47,5 @@
 #include "errors.h"
 
-/* FIXME: Just have find_command() return an allocated string */
-static char *found;
-
-static char *find_command(char *);
+static errno_t find_command(char *, char **);
 static int try_access(const char *);
 
@@ -68,30 +65,48 @@
 }
 
-/** Returns the full path of "cmd" if cmd is found
+/** Returns EOK if no internal failure or else ENOMEM
  *
- * else just hand back cmd as it was presented
+ * When the parameter `cmd` can be found then the absolute path will be set in `found`.
+ * Or else `found` will be NULL.
+ * `found` will be newly allocated and must be freed by the caller
  */
-static char *find_command(char *cmd)
+static errno_t find_command(char *cmd, char **found)
 {
-	size_t i;
+	/* The user has specified a full or relative path, just give it back. */
+	if (is_path(cmd)) {
+		if (-1 != try_access(cmd)) {
+			*found = str_dup(cmd);
+			return EOK;
+		}
 
-	found = (char *)malloc(PATH_MAX);
+		*found = NULL;
+		return EOK;
+	}
 
-	/* The user has specified a full or relative path, just give it back. */
-	if (-1 != try_access(cmd)) {
-		return (char *) cmd;
+	*found = (char *)malloc(PATH_MAX);
+	if (*found == NULL) {
+		return ENOMEM;
 	}
 
 	/* We now have n places to look for the command */
+	size_t i;
+	size_t cmd_length = str_length(cmd);
 	for (i = 0; search_dir[i] != NULL; i++) {
-		memset(found, 0, PATH_MAX);
-		snprintf(found, PATH_MAX, "%s/%s", search_dir[i], cmd);
-		if (-1 != try_access(found)) {
-			return (char *) found;
+		if (str_length(search_dir[i]) + cmd_length + 2 > PATH_MAX) {
+			free(*found);
+			return ENOMEM;
+		}
+
+		memset(*found, 0, PATH_MAX);
+		snprintf(*found, PATH_MAX, "%s/%s", search_dir[i], cmd);
+		if (-1 != try_access(*found)) {
+			return EOK;
 		}
 	}
+	free(*found);
+	*found = NULL;
 
-	/* We didn't find it, just give it back as-is. */
-	return (char *) cmd;
+	/* We didn't find it, return NULL */
+	return EOK;
 }
 
@@ -107,6 +122,14 @@
 	FILE *files[3];
 
-	tmp = str_dup(find_command(cmd));
-	free(found);
+	rc = find_command(cmd, &tmp);
+	if (rc != EOK) {
+		cli_error(CL_ENOMEM, "%s: failure executing find_command()", progname);
+		return 1;
+	}
+
+	if (tmp == NULL) {
+		cli_error(CL_EEXEC, "%s: Command not found '%s'", progname, cmd);
+		return 1;
+	}
 
 	files[0] = io->stdin;
Index: uspace/app/bdsh/util.c
===================================================================
--- uspace/app/bdsh/util.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ uspace/app/bdsh/util.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -74,2 +74,15 @@
 	return 0;
 }
+
+/*
+ * Returns true if the string is a relative or an absolute path
+ */
+bool is_path(const char *cmd)
+{
+
+	bool ret = str_lcmp(cmd, "/", 1) == 0;
+	ret = ret || str_lcmp(cmd, "./", 2) == 0;
+	ret = ret || str_lcmp(cmd, "../", 3) == 0;
+
+	return ret;
+}
Index: uspace/app/bdsh/util.h
===================================================================
--- uspace/app/bdsh/util.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ uspace/app/bdsh/util.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -31,8 +31,10 @@
 
 #include "scli.h"
+#include <stdbool.h>
 
 /* Utility functions */
 extern unsigned int cli_count_args(char **);
 extern unsigned int cli_set_prompt(cliuser_t *usr);
+extern bool is_path(const char *cmd);
 
 #endif
Index: uspace/app/contacts/contacts.c
===================================================================
--- uspace/app/contacts/contacts.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ uspace/app/contacts/contacts.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -526,5 +526,5 @@
 {
 	errno_t rc;
-	contacts_t *contacts;
+	contacts_t *contacts = NULL;
 
 	rc = contacts_open("contacts.sif", &contacts);
Index: uspace/app/df/df.c
===================================================================
--- uspace/app/df/df.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ uspace/app/df/df.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -70,5 +70,5 @@
 
 	/* Parse command-line options */
-	while ((optres = getopt(argc, argv, ":ubh")) != -1) {
+	while ((optres = getopt(argc, argv, "ubh")) != -1) {
 		switch (optres) {
 		case 'h':
@@ -78,10 +78,4 @@
 		case 'b':
 			display_blocks = true;
-			break;
-
-		case ':':
-			fprintf(stderr, "Option -%c requires an operand\n",
-			    optopt);
-			errflg++;
 			break;
 
Index: uspace/app/fontviewer/fontviewer.c
===================================================================
--- uspace/app/fontviewer/fontviewer.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ uspace/app/fontviewer/fontviewer.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -41,10 +41,9 @@
 #include <window.h>
 #include <canvas.h>
-#include <surface.h>
-#include <codec/tga.h>
+#include <draw/surface.h>
+#include <draw/codec.h>
 #include <task.h>
-#include <drawctx.h>
-#include <font/embedded.h>
-#include <font/pcf.h>
+#include <draw/drawctx.h>
+#include <draw/font.h>
 #include <stdarg.h>
 #include <io/verify.h>
